"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const wrap = require("pandora-spawn-wrap");
const wrapFile = require.resolve('./spawnWrapper');
class SpawnWrapperUtils {
    static wrap() {
        if (!SpawnWrapperUtils.unwrapFn) {
            SpawnWrapperUtils.unwrapFn = wrap([wrapFile]);
        }
    }
    static unwrap() {
        if (SpawnWrapperUtils.unwrapFn) {
            this.unwrapFn();
            this.unwrapFn = null;
        }
    }
    static async transaction(fn) {
        SpawnWrapperUtils.wrap();
        let ret;
        let caughtError;
        try {
            ret = await fn();
        }
        catch (error) {
            caughtError = error;
        }
        finally {
            SpawnWrapperUtils.unwrap();
        }
        if (caughtError) {
            throw caughtError;
        }
        return ret;
    }
}
exports.SpawnWrapperUtils = SpawnWrapperUtils;
//# sourceMappingURL=SpawnWrapperUtils.js.map